n, q, k = map(int, input().split())
p = list(map(int, input().split()))

for _ in range(q):
    l, r = map(int, input().split())
    # Сортируем элементы в интервале от l до r
    p[l - 1:r] = sorted(p[l - 1:r])

# Выводим k-й элемент в окончательной последовательности p
print(p[k - 1])